/**
 * Copyright (C) 2002 Billy Biggs <vektor@dumbterm.net>.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef OUTPUTAPI_H_INCLUDED
#define OUTPUTAPI_H_INCLUDED

#include "input.h"

typedef struct output_api_s
{
    void (* init)( int inputwidth, int inputheight );
    void (* shutdown)( void );

    /* Returns pointers to the next output buffer. */
    void (* lock_output_buffer)( void );
    unsigned char *(* get_output_buffer)( void );
    int (* get_output_stride)( void );
    void (* unlock_output_buffer)( void );

    /* Output API for progressive displays. */
    void (* show_frame)( void );
    void (* wait_for_retrace)( void );

    /* Functions for all outputs. */
    void (* set_window_caption)( const char *caption );

    void (* poll_events)( input_t *in );
} output_api_t;

#endif /* OUTPUTAPI_H_INCLUDED */
